
#ifndef ARCBALL_H
#define ARCBALL_H


typedef struct {double x, y, z;} Vec3;
typedef struct {double x, y, z, w;} Quat;
typedef double Mat4[4][4];
enum QuatPart {X, Y, Z, W, QuatLen};

Vec3 MouseOnSphere(int mouse_x, int mouse_y, double w, double h, double ballRadius);
Quat Qt_FromBallPoints(Vec3 from, Vec3 to);
Quat Qt_Mul(Quat qL, Quat qR);
Mat4 *Qt_ToMatrix(Quat q, Mat4 out);
Quat Qt_Conj(Quat q);
void transpose(Mat4 a);
void qt_from_matrix( Mat4 R, Quat* myq);
Vec3 ConstrainToAxis(Vec3 loose, Vec3 axis);

#endif